/*
  d. bodnar  revised 6-16-2016 with Rotary Encoder
  modified msport 08-28-2017 for 0.96" 128x64 I2C display for accessories
  library SSD1306Ascii
  VersionNum 1.0
*/
#include "Arduino.h"
const int ledPin =  13;      // the number of the LED pin
int buttonPin = 4; // button on rotary
static int pinA = 2; // Rotary Encoder
static int pinB = 3; // Rotary Encoder
volatile byte aFlag = 0;
volatile byte bFlag = 0;
volatile byte encoderPos = 0;
volatile byte oldEncPos = 0;
volatile byte reading = 0;
int old_pos = encoderPos;
int dir = 0; // direction
int buttonState = 0;
int encoderChange = 0; // flag to show encoder changed

int LED = 13; // LED to blink when DCC packets are sent in loop

int AccessoryAddress = 1; // make address 1 active
int AccessoryAddressToReset = 0;
#include <Wire.h>
#include "SSD1306Ascii.h"
#include "SSD1306AsciiWire.h"
#define I2C_ADDRESS 0x3C // 0X3C+SA0 - 0x3C or 0x3D

char VERS = "1.0";
boolean blink = false;
boolean ledPin_state;
unsigned long DCCMillis = 0;        // will store time when command is triggered
unsigned long previousMillis = 0;        // will store last time LED was updated
unsigned long currentMillis = millis();
const long interval = 300;
int debug = 0; // set to 1 to show debug info on serial port - may cause issues with DCC++ depending on what is sent
SSD1306AsciiWire oled;

//------------------------------------------------------------------------------
void setup() {
  pinMode(ledPin, OUTPUT);
  pinMode(pinA, INPUT_PULLUP); // set pinA as an input, pulled HIGH to the logic voltage (5V or 3.3V for most cases)
  pinMode(pinB, INPUT_PULLUP); // set pinB as an input, pulled HIGH to the logic voltage (5V or 3.3V for most cases)
  pinMode(buttonPin, INPUT);
  attachInterrupt(0, PinA, RISING); // set an interrupt on PinA, looking for a rising edge signal and executing the "PinA" Interrupt Service Routine (below)
  attachInterrupt(1, PinB, RISING); // set an interrupt on PinB, looking for a rising edge signal and executing the "PinB" Interrupt Service Routine (below)
  pinMode(LED, OUTPUT);
  
  Wire.begin();         
  oled.begin(&Adafruit128x64, I2C_ADDRESS);
  oled.set400kHz();
// oled.setFont(fixed_bold10x15);  
  oled.setFont(System5x7);  
//  oled.setFont(Callibri11_bold);    
//  oled.setFont(Arial_bold_14);  
  oled.set2X();
  oled.clear();  
  Serial.begin (115200);
  buttonState = digitalRead(buttonPin);
  if (buttonState == LOW) {
  oled.println("Commande ");
  oled.println("Accessoires ");
  oled.println(VERS);
  delay(2000);
  doDCC();
  do {                // todo enter debug ? routine to stay here till button released 
      buttonState = digitalRead(buttonPin);

              }      while (buttonState == LOW);
  }

  oled.clear();
  oled.println("DCC++");
  oled.println("Accessories");
  oled.println("Throttle 3");
//  oled.print("Vers: ");  
//  oled.println(VERS);  
  oled.println("9-11-2017"); 
  
  if (debug == 1) Serial.println("");
  Serial.print("<0>");// power off to DCC++ unit
  delay(1500);
  pinMode(ledPin, OUTPUT);              // Sets the digital pin as output.
  digitalWrite(ledPin, HIGH);           // Turn the LED on.
  ledPin_state = digitalRead(ledPin);   // Store initial LED state. HIGH when LED is on.
  oled.clear();
  doMainLCD(); // <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
}  // END SETUP



void loop() {


  // ROUTINE USING ROTARY ENCODER FOR ACCESSORY ADDRESS AND BUTTON ON IT FOR TRIGGER IT
  getEncoder();
  if (encoderChange == 1) {
    encoderChange = 0;
    AccessoryAddress = encoderPos;
    doMainLCD();
  }

  if (AccessoryAddressToReset != 0) {
    if ( millis() > DCCMillis + 600) {
    doResetDCC();
    AccessoryAddressToReset = 0;
    }
  }
  
  buttonState = digitalRead(buttonPin);
  if (buttonState == LOW) {
    delay(50);
    buttonState = digitalRead(buttonPin); // check a 2nd time to be sure
    if (buttonState == LOW) {// check a 2nd time to be sure
      if (AccessoryAddress == 0) {
        digitalWrite(ledPin, LOW);
      }
      else digitalWrite(ledPin, HIGH);
      doDCC();
      oled.setCursor(0, 6); // start of 4th line
      oled.print("COMMAND");      
      oled.print(" ");
      oled.print(AccessoryAddress, DEC);
      do {  // routine to stay here till button released & not toggle direction
        buttonState = digitalRead(buttonPin);
      }      while (buttonState == LOW);
      doMainLCD();
    }
  }

}  //END LOOP

void getEncoder() {
  if (oldEncPos != encoderPos) {
    encoderPos = constrain(encoderPos, 1, 64);
    oldEncPos = encoderPos;
    encoderChange = 1; // flag to show a change took place
  }
}//END GET ENCODER ROUTINE

void doDCC() {
  if (debug == 1) Serial.println(AccessoryAddress);
  Serial.print ("<1>");
  Serial.print ("<a ");
  Serial.print ((( AccessoryAddress - 1 ) / 4) + 1 ); // Accessory Address, DCC++ works with address + sub address
  Serial.print (" ");
  Serial.print (( AccessoryAddress - 1 ) % 4 );  // Accessory Sub Address 
  Serial.println (" 1 >");
  DCCMillis = millis();
  AccessoryAddressToReset = AccessoryAddress ;
}

void doResetDCC() {
  if (debug == 1) Serial.println(AccessoryAddressToReset);
  Serial.print ("<1>");
  Serial.print ("<a ");
  Serial.print ((( AccessoryAddressToReset - 1 ) / 4) + 1 ); // Accessory Address, DCC++ works with address + sub address
  Serial.print (" ");
  Serial.print (( AccessoryAddressToReset - 1 ) % 4 );  // Accessory Sub Address 
  Serial.println (" 0 >");
  AccessoryAddressToReset = 0 ;
}


void doMainLCD() {
  oled.setCursor(0,0); // 24,0
  oled.print("A= ");
  oled.print(AccessoryAddress, DEC); 
  oled.print(" ");
  oled.setCursor(0, 2); //
  oled.print(((AccessoryAddress - 1) / 4) + 1, DEC ); // main address
  oled.print(" / ");  
  oled.print(((AccessoryAddress-1) % 4 ), DEC );  // sub address
  oled.print("  ");    
  oled.setCursor(96, 2); // before last character line 2
  oled.print("#");
//  oled.setCursor (108, 2);       // go to end of 2nd line last character
//  oled.print(AccessoryAddress + 1);
  oled.setCursor(0, 4); // start of 3rd line 
//  oled.setCursor(84,0);
  if (AccessoryAddress % 2 ) {
    oled.print("Normal");
  }
  else {
    oled.print("Devie ");
  }
  oled.setCursor(0, 6); // start of 4th line
  oled.print("          ");      
  }

void PinA() {
  cli(); //stop interrupts happening before we read pin values
  reading = PIND & 0xC; // read all eight pin values then strip away all but pinA and pinB's values
  if (reading == B00001100 && aFlag) { //check that we have both pins at detent (HIGH) and that we are expecting detent on this pin's rising edge
    if (encoderPos != 0)encoderPos --; //decrement the encoder's position count
    bFlag = 0; //reset flags for the next turn
    aFlag = 0; //reset flags for the next turn
  }
  else if (reading == B00000100) bFlag = 1; //signal that we're expecting pinB to signal the transition to detent from free rotation
  sei(); //restart interrupts
}

void PinB() {
  cli(); //stop interrupts happening before we read pin values
  reading = PIND & 0xC; //read all eight pin values then strip away all but pinA and pinB's values
  if (reading == B00001100 && bFlag) { //check that we have both pins at detent (HIGH) and that we are expecting detent on this pin's rising edge
    encoderPos ++; //increment the encoder's position count
    bFlag = 0; //reset flags for the next turn
    aFlag = 0; //reset flags for the next turn
  }
  else if (reading == B00001000) aFlag = 1; //signal that we're expecting pinA to signal the transition to detent from free rotation
  sei(); //restart interrupts
}

